#ifndef KYSEC_GET_PROCESS_INFO_H_
#define KYSEC_GET_PROCESS_INFO_H_

#ifdef __cplusplus
extern "C" {
#endif

/* 进程信息 */
typedef struct _process_info
{
    long proc_pid; //进程id
    char proc_name[128]; //进程名
    char proc_path[1024]; //进程进行路径
    char proc_pwd[1024]; //进程工作目录
    char proc_command[4096]; //进程启动的命令行,包含启动参数
    long proc_ppid; //父进程id
    int proc_uid; //进程所属用户　用户uid
    char start_time[128]; //进程启动的时间 (char * ctime(time_t time) 函数返回值Tue Jul 28 08:50:26 2020)
    int proc_tty; //任务的tty终端的设备号 tty_nr
    unsigned long utime; //进程cpu使用时间,单位s
    double proc_cpu; //进程cpu使用率 %
    double proc_mem; //进程mem使用量 %
    int net_file_num; //进程网络连接数
    int thread_num; //进程的线程数
    short proc_state; //进程状态
        /*
        0 R PROC_STAT_RUNNING
        1 S PROC_STAT_STOPPED
        2 Z PROC_STAT_SLEEPING              
        3 T PROC_STAT_ZOMBIE
        4 t PROC_STAT_TRACE
        5 D PROC_STAT_WAITING
        6 X PROC_STAT_DEAD
        */
    int file_num; //进程打开的文件数
    char **filename; //进程打开的文件名
} _process_info;

/*
功能：
        获取进程信息
输入：
        无
输出：
        _process_info: 获取到的进程结构体信息
             proc_num: 获取的进程数
返回：
        成功：0, -1失败
*/
int kysec_get_process_info(_process_info *info, unsigned int *proc_num);

#endif /* KYSEC_GET_PROCESS_INFO_H_ */
